Mantis Bug Tracker

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0004867OCamlOCaml generalpublic2009-09-17 19:372011-05-29 12:20
Reporterkiyoshi 
Assigned To 
PrioritynormalSeveritymajorReproducibilityalways
StatusclosedResolutionfixed 
PlatformOSOS Version
Product Version3.11.1 
Target VersionFixed in Version3.11.2+dev 
Summary0004867: ocamlopt -shared failed on Mac OS X 10.6 Snow Leopard (x86_64)
Descriptionocamlopt -shared failed as follows:

$ cat test.ml
type t = A | B | C | D

let f x = match x with A -> "A" | B -> "B" | C -> "C" | D -> "D"
$ ocamlopt -version
3.11.1
$ ocamlopt -shared test.ml -o dummy
ld: warning: -read_only_relocs cannot be used with x86_64
ld: pointer in read-only segment not allowed in slidable image, used in .L105 from test.o
collect2: ld returned 1 exit status
File "caml_startup", line 1, characters 0-1:
Error: Error during linking
$ ocamlopt -s -shared test.ml -o dummy
ld: warning: -read_only_relocs cannot be used with x86_64
ld: pointer in read-only segment not allowed in slidable image, used in .L105 from test.o
collect2: ld returned 1 exit status
File "caml_startup", line 1, characters 0-1:
Error: Error during linking
$ cat test.s
--- snip ---
_camlTest__f_67:
.L104:
        sarq $1, %rax
        leaq .L105(%rip), %r11
        jmp *(%r11, %rax, 8)
        .const
        .align 3
.L105: .quad .L103
        .quad .L102
        .quad .L101
        .quad .L100
--- snip ---
$


A dirty patch attached to this report will resolve this problem.
Additional Information$ uname -v
Darwin Kernel Version 10.0.0: Fri Jul 31 22:47:34 PDT 2009; root:xnu-1456.1.25~1/RELEASE_I386
$ sw_vers
ProductName: Mac OS X
ProductVersion: 10.6.1
BuildVersion: 10B504
$ port version
Version: 1.8.0
$ port list installed | grep ocaml
ocaml @3.11.1 private/ocaml
$
TagsNo tags attached.
Attached Filesdiff file icon patch-asmcomp-amd64-emit.mlp.diff [^] (1,910 bytes) 2009-09-17 19:37 [Show Content]

- Relationships

-  Notes
(0005112)
xleroy (administrator)
2009-09-18 16:29

Thanks for the patch, which was a very useful starting point. Tentative fix in 3.11 release branch, will go in 3.11.2. The warning about "-read_only_relocs" doesn't show up on my Mac OS 10.5 test machine; we'll address it when testing under 10.6 soon.

- Issue History
Date Modified Username Field Change
2009-09-17 19:37 kiyoshi New Issue
2009-09-17 19:37 kiyoshi File Added: patch-asmcomp-amd64-emit.mlp.diff
2009-09-18 15:48 xleroy Relationship added related to 0004760
2009-09-18 16:29 xleroy Note Added: 0005112
2009-09-18 16:29 xleroy Status new => resolved
2009-09-18 16:29 xleroy Resolution open => fixed
2009-09-18 16:29 xleroy Fixed in Version => 3.11.2+dev
2011-05-29 12:20 xleroy Status resolved => closed


Copyright © 2000 - 2011 MantisBT Group
Powered by Mantis Bugtracker